/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include <string>

#include "CoreMinimal.h"
#include "Engine/Engine.h"
#include "IHeadMountedDisplay.h"

#include "MixCastDefines.h"
#include "MixCastSdkActor.h"
#include "Utility/MathUtil.hpp"
#include "MixCast/Private/Transmission/Generated/TrackingSource_types.h"

#if UE_4_18_OR_LATER
#include "IXRTrackingSystem.h"
#endif

class MIXCAST_API TrackingUtil
{
private:
	static mixcast::data::TrackingSource::type TrackingTypeOverride;

public:
	static void SetOverrideTrackingType(mixcast::data::TrackingSource::type type);
	static mixcast::data::TrackingSource::type GetCurrentTrackingType(bool ignoreOverride);
};
