#pragma once

#include "WatchedUnrealSharedTexture.h"

#if MIXCAST_D3D12
typedef struct ID3D12Device;
typedef struct ID3D12Resource;

class WatchedUnrealSharedTexture_D3D12 : public WatchedUnrealSharedTexture
{
private:
	HANDLE localHandle = 0;

	ID3D12Resource* sharedTex = NULL;
	unsigned long width = 0, height = 0;

	FTexture2DRHIRef sharedTexRhi;

	void Initialize(HANDLE texHandle);

public:
	WatchedUnrealSharedTexture_D3D12(HANDLE srcProcHandle, HANDLE remoteTexHandle)
	{
		if (DuplicateHandle(srcProcHandle, remoteTexHandle, GetCurrentProcess(), &localHandle, NULL, true, DUPLICATE_SAME_ACCESS))
			Initialize(localHandle);
	}

	virtual void Read_RenderThread(FRHICommandListImmediate& RHICmdList) override;

	virtual void BeginDestroy() override;
};
#endif