/**********************************************************************************
* Blueprint Reality Inc. CONFIDENTIAL
* 2020 Blueprint Reality Inc.
* All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains, the property of
* Blueprint Reality Inc. and its suppliers, if any.  The intellectual and
* technical concepts contained herein are proprietary to Blueprint Reality Inc.
* and its suppliers and may be covered by Patents, pending patents, and are
* protected by trade secret or copyright law.
*
* Dissemination of this information or reproduction of this material is strictly
* forbidden unless prior written permission is obtained from Blueprint Reality Inc.
***********************************************************************************/

#pragma once

#include "CoreMinimal.h"
#include "Modules/ModuleInterface.h"
#include "Modules/ModuleManager.h"

#define MIXCAST_SDK_MAJOR_VERSION 2
#define MIXCAST_SDK_MINOR_VERSION 5
#define MIXCAST_SDK_PATCH_VERSION 0

class FServiceSDKHandler;
class AMixCastSdkActor;

class MIXCAST_API IMixCast : public IModuleInterface
{
public:
	static const inline FString GetPluginName()
	{
		return "MixCast";
	}
	static inline IMixCast& Get()
	{
		static const FName PluginName(*GetPluginName());
		return FModuleManager::LoadModuleChecked<IMixCast>(PluginName);
	}
	static inline bool IsAvailable()
	{
		static const FName PluginName(*GetPluginName());
		return FModuleManager::Get().IsModuleLoaded(PluginName);
	}

	virtual bool IsActive() = 0;
	DECLARE_EVENT(IMixCast, FActivationEvent)
	virtual FActivationEvent& OnActiveChanged() = 0;

	virtual bool SendExperienceEvent(const FString& EventId) = 0;

	DECLARE_EVENT_OneParam(FServiceSDKHandler, FReceivedCommandEvent, FString)
	virtual FReceivedCommandEvent& OnCommandReceived() = 0;

	DECLARE_EVENT(FServiceSDKHandler, FTrackingSpaceChangedEvent)
	virtual FTrackingSpaceChangedEvent& OnTrackingSpaceChanged() = 0;

	DECLARE_EVENT(AMixCastSdkActor, FBeforeFrameEvent)
	virtual FBeforeFrameEvent& OnBeforeFrame() = 0;
};

